import React from "react";
import {useDispatch} from "react-redux";
import {DELETE_TODO, TOGGLE_TODO} from "./reducers";

interface TodoProps {
    id: number;
    text: string;
    completed: boolean;
}

const Todo = ( { id, text, completed }: TodoProps) => {
    const dispatch = useDispatch();
    const handleToggle = () => {
        dispatch({ type: TOGGLE_TODO, payload: id });
    };

    const handleDelete = () => {
        dispatch({ type: DELETE_TODO, payload: id });
    };

    return (
        <li>
            <input type="checkbox" checked={completed} onChange={handleToggle} />
            <span style={{ textDecoration: completed ? "line-through" : "none"}}>
                {text}
            </span>
            <button onClick={handleDelete}>Delete</button>
        </li>
    );
};

export default Todo;
